Subject: Re: status signalling of MPLS PW state

From: Luca Martini <[email-masked]>
Date: Wed, 11 Jun 2003 17:03:27 -0600

I read the following TLVs in the 
draft-shah-pwe3-control-protocol-extension-00.txt :

Operational Status TLV
IP Address TLV
IP+MAC Address TLV
Pseudowire QOS TLV

I think most of these are needed , but they need not all be part of the FEC.
There are several bits available in the status TLV proposal, can you please 
specify what the use should be, and I can add it.
( please note that the draft-shah does not propose much in the area of status )

Thanks.
Luca

Andrew G. Malis wrote:
> Hamid,
> 
> Well, they're really two alternative ways to extend LDP to convey the 
> same information.  The only way to really merge them would be to support 
> them both ....
> 
> Thanks,
> Andy
> 
> ---------
> 
> At 6/11/2003 04:48 PM -0400, Hamid Ould-Brahim wrote:
> 
>> Andy,
>>
>> [clipped]...
>>
>> >
>> > I certainly agree that one or the other is needed,
>>
>> How about both proposals to be merged (when possible/applicable)?
>>
>> Hamid.
>

---

From: Luca Martini <[email-masked]>
Date: Wed, 11 Jun 2003 17:06:41 -0600

Latest text, including some of the feedback.

.Pb "Signaling of Pseudo Wire Link Status"

.Pc "Use of Label Mappings."
The PEs MUST send PW label mapping messages to their peers as soon as the PW
is configured and administratively enabled, regardless of the CE interface
state. The PW label should not be withdrawn unless the user administratively
configures the CE interface down (or the PW configuration is deleted
entirely).
A simple label withdraw method SHOULD also be supported as an alternative.

.Pc "Signaling PW Link status."
When PWLE mode is in use, the PE devices use a new LDP TLV to
indicate status to their remote peers, instead of withdrawing their
PW FEC labels.  This Link Status TLV contains more information than
the simple Label Withdraw message used in the baseline signaling.

The format of the Link Status TLV is:
.DS 0 0
  0                   1                   2                   3
  0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|1|0|   Link Status (0x0700)    |      Length                   |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|         Status Code           |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
.DE

Where status is a 2 octet bit field:

.nf
0x0000 - Pseudo Wire forwarding ( clear all failures )
0x0001 - Pseudo Wire Not Forwarding
0x0002 - Local Customer-facing Interface Receive Fault
0x0004 - Local Customer-facing Interface Transmit Fault
0x0008 - Local Core-facing Interface Receive Fault
0x0010 - Local Core-facing Interface Transmit Fault
.En

The above status codes can be logically combined to indicate more then a
single failure at once.

The presence of the lowest bit (PW Not Forwarding) acts only as a
generic failure indication when there is a link-down event for
which none of the other bits apply.

The Link Status TLV is transported to the remote PW peer via a new
LDP message, the PW Link Status Message.

The format of the PW Link Status Message is:

.DS 0 0
  0                   1                   2                   3
  0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|1|   PW Link Status (0x0700)   |      Message Length           |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                           Message ID                          |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                           PW FEC TLV                          |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                         Link Status TLV                       |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                      Optional Parameters                      |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
.DE

When a PE's CE-facing interface encounters an error, use of the new message
allows the PE to send a single Link Status message, using a PW FEC TLV with
only the group ID set, to denote this change in status for all affected PW
connections.